package com.ibm.samples;
import java.io.*;
import java.net.*;
import java.util.*;
import com.ibm.broker.plugin.*;
public class PORTCommand extends FTPDCommand {
	PORTCommand() {
	}
	boolean execute(String parameters, WMQI_FTPSession session) throws Exception {
		PrintWriter reply = session.getReply();
		StringTokenizer st = new java.util.StringTokenizer(parameters, ",");
		int step;
		int[] tokens = new int[6];

		reply.flush();
		try {
			java.awt.Toolkit.getDefaultToolkit().beep();
			//--------------------------------------------------------------------------
			// get all tokens separated by a "," first four are ip address next are port
			for (step = 0; step < 6; step++) {
				if (st.hasMoreTokens()) {
					String token = st.nextToken().trim();
					tokens[step] = Integer.parseInt(token);
					//----------------
					// first four tokens are ip address check that it is between 0 and 255
					if (step < 4) {
						if (tokens[step] < 0 || tokens[step] > 255) {
							throw new Exception("Port step "+step+" error");
						}
					}
				}
			}
			session.setDataport((tokens[4] << 8) + tokens[5]);
			session.setDataAddress(
				tokens[0] + "." + tokens[1] + "." + tokens[2] + "." + tokens[3]);
			reply.println("200 PORT command successful "+parameters);

		} catch (Exception e) {
			reply.println("500 PORT command failed: " + parameters);
		}
		return true;
	}
}